Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.basex.query.expr
Class Pos

    java.lang.Object
      org.basex.query.ExprInfo
          org.basex.query.expr.Expr
              org.basex.query.expr.Simple
                  org.basex.query.expr.Pos

    public final class Pos

extends Simple

Pos Expression.

Author:
  Workgroup DBIS, University of Konstanz 2005-09, ISC License, Christian Gruen

Method Summary
`Bln` | `atomic(QueryContext ctx)` Evaluates the expression and returns the resulting item or a null reference.
`static Expr` | `get(Expr expr, CmpV.Comp cmp, Expr arg)` Returns an instance of this class, if possible, and the input expression otherwise.
`static Expr` | `get(long mn, long mx)` Returns an position or an optimized expression.
`boolean` | `last(QueryContext ctx)` Returns false if no more results can be expected.
`void` | `plan(Serializer ser)` Recursively sends the abstract syntax of this expression to the specified serializer.
`Return` | `returned(QueryContext ctx)` Indicates the return type of an expression.
`java.lang.String` | `toString()`
`boolean` | `uses(Expr.Use use, QueryContext ctx)` Indicates if an expression uses the specified type.

Methods inherited from class org.basex.query.expr.Simple
`color, comp`

Methods inherited from class org.basex.query.expr.Expr
`addText, checkCtx, checkDbl, checkItr, duplicates, e, ebv, i, indexAccessible, indexEquivalent, iter, removable, remove, sameAs, size, test`

Methods inherited from class org.basex.query.ExprInfo
`info, name`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### get

    public static Expr get(long mn,
                           long mx)

  Returns an position or an optimized expression.

  Parameters:
    `mn` - minimum value
    `mx` - minimum value
  Returns:
    expression

### get

    public static Expr get(Expr expr,
                           CmpV.Comp cmp,
                           Expr arg)
                    throws QueryException

  Returns an instance of this class, if possible, and the input expression otherwise.

  Parameters:
    `expr` - calling expression
    `cmp` - comparator
    `arg` - argument
  Returns:
    resulting expression
  Throws:
    `QueryException` - evaluation exception

### atomic

    public Bln atomic(QueryContext ctx)
               throws QueryException

  Description copied from class: `Expr`
  Evaluates the expression and returns the resulting item or a null reference. If this method is not overwritten, `Expr.iter(org.basex.query.QueryContext)` must be implemented.

  Overrides:
    `atomic` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    iterator
  Throws:
    `QueryException` - query exception

### last

    public boolean last(QueryContext ctx)

  Returns false if no more results can be expected.

  Parameters:
    `ctx` - query context
  Returns:
    result of check

### uses

    public boolean uses(Expr.Use use,
                        QueryContext ctx)

  Description copied from class: `Expr`
  Indicates if an expression uses the specified type. Called by the compiler to perform certain optimizations. `true` is returned by default and thus assumed as "worst-case".

  Overrides:
    `uses` in class `Simple`
  Parameters:
    `use` - use type to be checked
    `ctx` - query context
  Returns:
    result of check

### returned

    public Return returned(QueryContext ctx)

  Description copied from class: `Expr`
  Indicates the return type of an expression. Called by the compiler to check if expressions can be reformulated. null is returned by default.

  Overrides:
    `returned` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    result of check

### toString

    public java.lang.String toString()

  Specified by:
    `toString` in class `ExprInfo`

### plan

    public void plan(Serializer ser)
              throws java.io.IOException

  Description copied from class: `ExprInfo`
  Recursively sends the abstract syntax of this expression to the specified serializer.

  Overrides:
    `plan` in class `Simple`
  Parameters:
    `ser` - serializer
  Throws:
    `java.io.IOException` - exception

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD